#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "is_exiting4xi.py">
#<abstract4xi abstract = " providing is_exiting4xi function to manage global variable _exiting4xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'is_exiting4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import weakref
    import atexit         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:                             # Python ones
    from multiprocessing.util import is_exiting
except:
    print("is_exiting4xi.py *** failed in from multiprocessing.util import is_exiting ***") 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from time4xi import time4xi 
from print4xi import print4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global objects of DragonXi                             
# -------------------------------------------------------------------------------------------------
global _exiting4xi                             

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
_exiting4xi = None
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "is_exiting4xi" usage = "
#   to check if the process is shutting down using dragonized global variable _exiting4xi
#"> 
# -------------------------------------------------------------------------------------------------
def is_exiting4xi():
    '''
    Returns true if the process is shutting down
    '''
    global _exiting4xi

    class2print = "is_exiting4xi"
    method2print = "is_exiting4xi"
    
    message2print = "{started" + "; is-exiting4xi-started: " + str(is_exiting4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # 
    
    if _exiting4xi is None:
        init_exiting4xi(False)
        
        message2print = "{set" + "; _exiting4xi-set-by-is-exiting4xi to: " + str(False)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
    else:    
    
        message2print = "{using" + "; _exiting4xi-using-by-is-exiting4xi: " + str(_exiting4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
            
    status2shutdown = _exiting4xi or _exiting4xi is None

    message2print = "{returning" + "; status2shutdown-returning-by-is-exiting4xi: " + str(status2shutdown) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
    # 
            

    return status2shutdown

#</function4xi> 
 

   
# -------------------------------------------------------------------------------------------------
# init_exiting4xi                              
#     set by process4xi.py function _bootstrap
#<function4xi function = "init_exiting4xi" usage = "
# initializes _exiting4xi
#"> 
# -------------------------------------------------------------------------------------------------
def init_exiting4xi(param=None):
    '''
    initializes _exiting4xi
    '''
    global _exiting4xi
    
    class2print = "init_exiting4xi"
    method2print = "init_exiting4xi"
    
    message2print = "{started" + "; init-exiting4xi-started: " + str(init_exiting4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    
    if param is None:
        param = False
        
    _exiting4xi = param

    message2print = "{initialized" + "; _exiting4xi-initialized-by-init-exiting4xi to: " + str(_exiting4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    
    message2print = "{returning" + "; init-exiting4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                        
#</function4xi> 
     
# -------------------------------------------------------------------------------------------------
# set_exiting4xi                              
#<function4xi function = "set_exiting4xi" usage = "
# sets _exiting4xi
#"> 
# -------------------------------------------------------------------------------------------------
def set_exiting4xi(param=None):
    '''
    sets _exiting4xi
    '''
    global _exiting4xi
    
    class2print = "set_exiting4xi"
    method2print = "set_exiting4xi"
    
    message2print = "{started" + "; set-exiting4xi-started: " + str(set_exiting4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
  
      
    
    if param is None:
        param = False
        
    _exiting4xi = param    

    message2print = "{set" + "; _exiting4xi-set-by-set-exiting4xi to: " + str(_exiting4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{returning" + "; set-exiting4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                 
#</function4xi> 
           
# -------------------------------------------------------------------------------------------------
# get_exiting4xi                              
#<function4xi function = "get_exiting4xi" usage = "
# gets _exiting4xi
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def get_exiting4xi():
    '''
    gets _exiting4xi
    '''
    global _exiting4xi
    
    class2print = "get_exiting4xi"
    method2print = "get_exiting4xi"
    
    message2print = "{started" + "; get-exiting4xi-started: " + str(get_exiting4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
  
    if _exiting4xi is None:
        init_exiting4xi(False)
        message2print = "{set" + "; _exiting4xi-set-by-get-exiting4xi to: " + str(_exiting4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
          
    message2print = "{returning" + "; exiting4xi-returning-by-get-exiting4xi: " + str(_exiting4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
        
    
    return _exiting4xi
    
#</function4xi> 
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of is_exiting4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

